Public Member Functions | Friends | List of all members
cgicc::MStreamable Class Referenceabstract

Mix-in streamable interface. More...

`#include <cgicc/MStreamable.h>`

Inheritance diagram for cgicc::MStreamable:

## Public Member Functions
| MStreamable ()
| Empty constructor. More...
virtual | ~MStreamable ()
| Empty destructor. More...
virtual void | render (std::ostream &out) const =0
| Write this object to a stream. More...

## Friends
std::ostream & | operator<< (std::ostream &out, const MStreamable &obj)

## Detailed Description

Mix-in streamable interface.

Abstract mix-in class which makes classes streamable via the `<<` operator. Written in the spirit of a Java interface.

Definition at line 66 of file MStreamable.h.

## Constructor & Destructor Documentation

## ◆ MStreamable()

cgicc::MStreamable::MStreamable | ( |  | ) |
| inline

Empty constructor.

Definition at line 77 of file MStreamable.h.

## ◆ ~MStreamable()

virtual cgicc::MStreamable::~MStreamable | ( |  | ) |
| inline virtual

Empty destructor.

Definition at line 84 of file MStreamable.h.

## Member Function Documentation

## ◆ render()

virtual void cgicc::MStreamable::render | ( | std::ostream & | out | ) | const
| pure virtual

Write this object to a stream.

Subclasses must implement this function.

Parameters

  out | The ostream to which to write.

Implemented in cgicc::HTMLAttribute, cgicc::HTMLDoctype, cgicc::HTMLElement, cgicc::HTTPContentHeader, cgicc::HTTPCookie, cgicc::HTTPRedirectHeader, cgicc::HTTPResponseHeader, cgicc::HTTPStatusHeader, cgicc::XHTMLDoctype, cgicc::XMLPI, and cgicc::HTTPHeader.

## Friends And Related Function Documentation

## ◆ operator<<

std::ostream & operator<< | ( | std::ostream & | out,
|  | const MStreamable & | obj
| ) |  |
| friend

Prototype for overloading streaming operator

Parameters

  out | The ostream to which to write
  obj | The MStreamable object to write

Returns
  A reference to `out`

The documentation for this class was generated from the following file:

- MStreamable.h